#!/bin/bash

set -e
set -u

die() {
  echo "${1:-}"
  exit 1
}

if [ -z ${1:-} ]
then
  die "Error: first argument needs to be the output of CBMC"
fi

if [ ! -f ${1:-} ]
then
  die "Error: file not found: $1"
fi

TMP_FILE="/tmp/pre_proc.tmp"

# File containing the happens-before formulas
FORMULA_FILE=formulas

# File containing the variable definitions
VAR_FILE=var_defs

# Remove everything up to the final output of the UNSAT cores
# Then, remove everything starting with a '#'
# Then, remove VERIFICATION FAILED
# Finally, remove blank lines

sed '1,/##### The result of the verification is: (The extra constraints added on hb properties)/d' $1 \
  | sed '/#/d' | sed '/VERIFICATION FAILED/d' | sed '/^$/d' >$TMP_FILE

# Next, split the formula and variable definitions
egrep '.+0$' $TMP_FILE >$FORMULA_FILE
egrep '.+\)$' $TMP_FILE >$VAR_FILE

# Remove the first variable from the formulas (not sure what its for...)
sed -i 's/^[0-9]\+ //g' $FORMULA_FILE

# Remove the last zero from each line from the formula file (it represents the
# end of a formula)
sed -i 's/ 0$//g' $FORMULA_FILE

