
#include <iostream>
#include <algorithm>
#include <vector>
#include <sstream>
#include <fstream>
#include <string>

#include "compute_unsat_core.h"
#include "msun.h"

std::vector<std::string> compute_unsat_core(int iter, int& round ){
    round = 0;

    std::vector<std::string> unsat_core;    //The actual whole unsat core in this iteration
    std::vector<std::string> unsat_clauses; //A mid value that keeps unsat clauses of each round
    std::string unsat_eqn;
    std::string unsat_eqn_init("/tmp/unsat_eqn" + intToString(iter));   //this is unsat_eqn#iter so far!
    
    std::fstream unsatEqn;
    
    bool unsat_core_completed = false;  // to know where we have found all the clauses in this iteration's unsat core
    
    while((round == 0) || !unsat_core_completed){
        
        std::string unsat_eqn(unsat_eqn_init + ((round == 0)?"":("_" + intToString(round-1))) + ".cnf");
        unsatEqn.open(unsat_eqn.data());
        unsatEqn.seekg(0,std::ios::end);
        
        char cmd[9064];
	//        sprintf(cmd, "%s -u -v 0 %s | awk '{if($1 ==\"s\" && $2 == \"UNSATISFIABLE\"){print(\"UNSATISFIABLE\") } else if($1 ==\"c\" && $2 != \"Unsat\" && $2 != \"CPU\") { print($0)  }}' > /tmp/unsat_tmp","../msuncore_20090525/bin/msuncore",unsat_eqn.data());
  
        //sprintf(cmd, "%s -u -v 0 %s > %s.out","~/Desktop/co/src/cbmc/msuncore_20090525/bin/msuncore",unsat_eqn.data(),unsat_eqn.data());
        sprintf(cmd, "%s -u -v 0 %s > %s.out",MSUNCORE_LOC,unsat_eqn.data(),unsat_eqn.data());
	system(cmd);
        //sprintf(cmd, "cat %s.out | awk '{if($1 ==\"s\" && $2 == \"UNSATISFIABLE\"){print(\"UNSATISFIABLE\") } else if($1 ==\"c\" && $2 != \"Unsat\" && $2 != \"CPU\") { print($0)  }}' > /tmp/unsat_tmp",unsat_eqn.data());
        sprintf(cmd, "cat %s.out > /tmp/unsat_tmp",unsat_eqn.data()); /*SEPI changed this*/
        system(cmd);
        
        unsatEqn.close();
        
        /*SEPI: now, printing some information for the unsat cores!*/
        std::ifstream unsatTmp("/tmp/unsat_tmp");
        unsat_clauses.clear();     //empty the unsat clauses vector
        std::string unsat_core_clause;

        bool reached_unsat_clauses = false;
        // fill unsat_clauses with all the clauses in this iteration's UNSAT core (newly found clauses)
        while (std::getline(unsatTmp, unsat_core_clause))
        {
            if(unsat_core_clause == "s UNSATISFIABLE"){
                //std::cout << "No more clause for iteration " << iter << "'s UNSAT Core" << "\n";
                unsat_core_completed = true;
                break;
            }
            if(unsat_core_clause.find("c CPU Time") != std::string::npos)
                break;
            if(unsat_core_clause == "c Unsat Clauses:"){
                reached_unsat_clauses = true;
                continue;
            }
            else if(reached_unsat_clauses){
                unsat_core_clause.replace(0,1,"1");
                unsat_clauses.push_back(unsat_core_clause);
            }
        }
        std::cout << "## iteration " << iter << " ## round " << round << " ## Number of new clauses found: " << unsat_clauses.size() << std::endl;
        if(unsat_core_completed){ /*SEPI this means the whole unsat core is found*/
            unsatEqn.close();
            return unsat_core;
        }
        
        if(unsat_clauses.empty() && round == 0){
            std::cout << "Formula in " << unsat_eqn << " is SATISFIABLE!" << std::endl;
            return unsat_core;
        }
        //now, writing the newly found unsat clauses to a new file unsat_eqn#iter_#round.cnf:
        std::string unsat_eqn_mid(unsat_eqn_init + "_" + intToString(round) + ".cnf");
        std::ofstream unsatEqnMid(unsat_eqn_mid.data());
       
        round++;
        std::string line;

        unsatEqn.open(unsat_eqn.data());
        if(unsatEqn.is_open()){
            std::getline(unsatEqn, line); //getting the first line to get some information
            std::vector<std::string> first_line = split(std::string(line), ' ');
            std::string numOfVars = first_line.at(2);
            std::string numOfClauses = first_line.at(3);
            std::string weight = first_line.at(4);

            
            unsatEqnMid << line;   //writing the header line
            while (std::getline(unsatEqn, line))
            {
                if(std::find(unsat_clauses.begin(), unsat_clauses.end(), line) != unsat_clauses.end()){
                    unsat_core.push_back(line);
                    std::cout << "New UNSAT clause: " << line << std::endl;
                    line = line.replace(0,1,weight);
                }
                unsatEqnMid << "\n" << line;
            }
        }
    }
    unsatEqn.close();
    return unsat_core;
}
/*******************************/
std::string negate_disjunction(std::vector<std::string> clauses){
    std::string negation = "";
    for(int i=0; i < clauses.size() ; i++){
        std::vector<std::string> clause = split(clauses.at(i), ' ');
        std::string hb = clause.at(1);
        negation += " " + intToString(-atoi(hb.c_str()));
    }
    return negation;
}
/*******************************/
std::string negate_disjunction_no_weight(std::vector<std::string> clauses){
    std::string negation = "";
    for(int i=0; i < clauses.size() ; i++){
        negation += " " + intToString(-atoi(clauses.at(i).c_str()));
    }
    return negation;
}
/*******************************/
void leftTrim(std::string& src, char chr)
{
    if(src == "0" || src == "00"){
        src = "0";
        return;
    }
    std::string::size_type pos =  src.find_first_not_of(chr,0);
    if(pos > 0)
        src.erase(0,pos);     
}
/*******************************/
std::string intToString(int i){
    std::ostringstream convert;
    convert.clear();
    convert.str("");
    convert << i;
    std::string dummy = convert.str();
    leftTrim(dummy, '0');
    return dummy;
}
