/*******************************************************************\

Module:

Author: Daniel Kroening, kroening@kroening.com

\*******************************************************************/

#include <cassert>
#include <stdlib.h>
#include <iostream>
#include <algorithm>

#include "prop.h"
#include "split.cpp"

/*******************************************************************\

Function: propt::set_equal

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void propt::set_equal(literalt a, literalt b)
{
  bvt bv;
  bv.resize(2);
  bv[0]=a;
  bv[1]=lnot(b);
  lcnf(bv);
  
  bv[0]=lnot(a);
  bv[1]=b;
  lcnf(bv);
}

/*******************************************************************\

Function: propt::set_assignment

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void propt::set_assignment(literalt a, bool value)
{
  assert(false);
}

/*******************************************************************\

Function: propt::copy_assignment_from

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

void propt::copy_assignment_from(const propt &src)
{
  assert(false);
}

/*******************************************************************\

Function: propt::is_in_conflict

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bool propt::is_in_conflict(literalt l) const
{
  assert(false);
  return false;
}

/*******************************************************************\

Function: propt::new_variables

  Inputs:

 Outputs:

 Purpose:

\*******************************************************************/

bvt propt::new_variables(unsigned width)
{
  bvt result;
  result.resize(width);
  for(unsigned i=0; i<width; i++)
    result[i]=new_variable();
  return result;
}

/*******************************************************************\

Function: propt::prop_write_to_file

  Inputs:

 Outputs:

 Purpose: writing the assertion-flipped Boolean formula into a file or on a screen

\*******************************************************************/
/*SEPI*/
int propt::write_to_file(std::ostream &out, std::vector<int> violated_assertion, int args_no) {    
    int i, lCSize, total_no_clauses;

    clause_cnt = SS.size()+VarLit.size();   //SEPI: I think I have never had VarLit in my examples.
    total_no_clauses = clause_cnt+hb_properties.size()+args_no-1;//+mm_properties.size();
    lCSize = total_no_clauses+1000;//clause_cnt+1000;
    
    out<<"p wcnf "<< /*no_literals()*/ no_variables()-1 <<" "<< total_no_clauses << " "<< lCSize << std::endl;
    for(i=0;i<SS.size();i++){
        out << lCSize << " ";
        std::vector<std::string> ss = split(SS[i], ' ');
        if(ss[1] == "0"){   //one variable clauses! assertions are of this type!
            int val = atoi(ss[0].c_str());
            if(std::find(violated_assertion.begin(), violated_assertion.end(),val) != violated_assertion.end()){
                out << -val << " 0" << std::endl;
            }
            else if(std::find(violated_assertion.begin(), violated_assertion.end(),-val) != violated_assertion.end()){
                out << -val << " 0" << std::endl;   // -val, because what is in val is what is in SS which is the assertion in violated form! we want the not violated form here
            }
            else
                out << SS[i] << std::endl;
        }
        else{
            out << SS[i] << std::endl;
        }
    }

    // SEPI: where is VarLit being initialized and updated? NOT SURE ABOUT THIS PART!
    //Generating counter example values in to the cnf. 
    for(i=0;i<VarLit.size();i++)
    {
            if(l_get(VarLit[i]).get_value() == tvt::TV_FALSE)
                    out<<lCSize<<" -"<<VarLit[i].var_no()<<" 0"<<std::endl;
            else
                    out<<lCSize<<" "<<VarLit[i].var_no()<<" 0"<<std::endl;	//Seems to be wrong!          
    }
    
    return lCSize;
}