/**
 * \file
 * \author Markus Kusano (mukusano@vt.edu)k
 * Example of bug #25520 in Apache 2.0.48 (a data race/atomicity violation)
 *
 * Source: http://web.eecs.umich.edu/~jieyu/bugs/apache-25520.html
 *
 * Bug Report: https://issues.apache.org/bugzilla/show_bug.cgi?id=25520
 *
 * See README.md or `html/index.html` for more information 
 */

#include <pthread.h>
#include <string.h>
#include <assert.h>

/* Comment out to suppress calls to printf() displaying debugging messages and
 * calls to nanosleep() to attempt to force the buggy interleaving */
//#define DEBUG

/*
#ifdef DEBUG
#include <stdio.h>
#include <time.h>
#endif
*/

/**
 * Array the threads will write to
 */
//char buffer[256];
//char buffer[2];
char b1;
char b2;

/**
 * Next open index in buffer
 */
int outcnt = 0;

/**
 * Write the passed char * to buffer
 *
 * \param s String to write to buffer
 * \return Returns NULL upon completion
 */
//void *writeSentence(void *s);

void *writeSentence_t1(void *s) {

#if 0
#ifdef DEBUG
    struct timespec waitTime;
    waitTime.tv_sec = 0;
    waitTime.tv_nsec = 1000;

    printf("Copying string\n");
#endif

    /* copy the string into buffer */
    memcpy(buffer + outcnt, (char *) s, strlen(s) + 1);

#ifdef DEBUG
    nanosleep(&waitTime, &waitTime);
    printf("Updating outcnt\n");
#endif
    outcnt = strlen(s) + 1;
#endif

    /*
    if (outcnt == 0) {
      b1 = 'a';
    }
    else {
      b2 = 'a';
    }
    */
    outcnt == 0 ? (b1 = 'a') : (b2 = 'a');
    outcnt++;

    //buffer[outcnt] = 'a';
    //outcnt++;


    return NULL;
}

void *writeSentence_t2() {

#if 0
#ifdef DEBUG
    struct timespec waitTime;
    waitTime.tv_sec = 0;
    waitTime.tv_nsec = 1000;

    printf("Copying string\n");
#endif

    /* copy the string into buffer */
    memcpy(buffer + outcnt, (char *) s, strlen(s) + 1);

#ifdef DEBUG
    nanosleep(&waitTime, &waitTime);
    printf("Updating outcnt\n");
#endif
    outcnt = strlen(s) + 1;
#endif

    /*
    if (outcnt == 0) {
      b1 = 'b';
    }
    else {
      b2 = 'b';
    }
    outcnt++;
    */
    outcnt == 0 ? (b1 = 'b') : (b2 = 'b');
    outcnt++;

    //buffer[outcnt] = 'b';
    //outcnt++;

    return NULL;
}

/**
 * Spawns two threads with to writeSentence() with two different setences to
 * write.
 *
 * \return Returns 0 upon completion
 */
int main() {
    pthread_t t1, t2;

#if 0
    /* Some pangrams to write to the buffer */
    char *sent1 = "The quick brown fox jumps over the lazy dog.";
    char *sent2 = "Vamp fox held quartz duck just by wing.";

#ifdef DEBUG
    printf("Spawning first thread\n");
#endif
    pthread_create(&t1, NULL, writeSentence, (void *) sent1);
#ifdef DEBUG
    printf("Spawning second thread\n");
#endif
    pthread_create(&t2, NULL, writeSentence, (void *) sent2);

#ifdef DEBUG
    /* Have main() wait until both sentences have been written */
    pthread_join(t1, NULL);
    pthread_join(t2, NULL);

    buffer[outcnt + 1] = '\0';

    printf("Final String: %s\n", buffer);

    return 0;
#endif

#ifndef DEBUG
    pthread_exit((void *) 0);
#endif
#endif

    // Initialize the buffer
    //buffer[0] = 'x';
    //buffer[1] = 'x';
    b1 = 'x';
    b2 = 'x';

    pthread_create(&t1, NULL, writeSentence_t1, NULL);
    pthread_create(&t2, NULL, writeSentence_t2, NULL);

    pthread_join(t1, NULL);
    pthread_join(t2, NULL);

    //if (buffer[0] != 'a' || buffer[0] != 'b') {
    //if (b1 != 'x' || b2 != 'b') {
    if (b2 == 'x') {
      assert(0);
    }

    //if (buffer[1] != 'a' || buffer[1] != 'b') {
    //if (b2 != 'a' || b2 != 'b') {
      //assert(0);
    //}

    return 0;

}
