#include <pthread.h>

#define assume(e) __VERIFIER_assume(e)
//#define assert(e) { if(!(e)) { ERROR: goto ERROR; (void)0; } }

volatile unsigned int count = 0; //shared
_Bool MTX = 0; //shared mutex
__thread _Bool COND = 0; //condition variables become local flag indicating whether the thread was signaled

void __VERIFIER_atomic_acquire()
{
	assume(MTX==0);
	MTX = 1;
}

void __VERIFIER_atomic_release()
{
	assume(MTX==1);
	MTX = 0;
}

#define cnd_wait(c,m){ \
  __VERIFIER_atomic_begin(); \
  assume(c); \
  c = 0; \
  __VERIFIER_atomic_end(); }

#define cnd_broadcast(c) (c = 1) //BP must be post-processed manually by changing "b*_COND := 1" to "b*_COND$ := 1"

void Barrier2_t1() {  
  count++;
  if (count == 3) { cnd_broadcast(COND); count = 0; return; }
  cnd_wait(COND,MTX);
}

void Barrier2_t2() {  
  count++;
  if (count == 3) { cnd_broadcast(COND); count = 0; return; }
  cnd_wait(COND,MTX);
}

void Barrier2_t3() {  
  count++;
  if (count == 3) { cnd_broadcast(COND); count = 0; return; }
  cnd_wait(COND,MTX);
}
  
void* thr1(void* arg){
  Barrier2_t1();
  assert(0);

  return 0;
} 

void* thr2(void* arg){
  Barrier2_t2();
  assert(0);

  return 0;
} 

void* thr3(void* arg){
  Barrier2_t3();
  assert(0);

  return 0;
} 

int main(){
  pthread_t t;

	//while(1) { pthread_create(&t, 0, thr1, 0); }
	pthread_create(&t, 0, thr1, 0);
	pthread_create(&t, 0, thr2, 0);
	pthread_create(&t, 0, thr3, 0);
}
