//NEWBUG01. race-condition found in iio-subsystem of linux-kernel. (http://wiki.analog.com/software/linux/docs/iio/iio)
//problem: use_count not locked from concurrent access. leads to miss-behaving notification-behaviour
//url: https://github.com/torvalds/linux/commit/a1a8e1dc111d6f05e7164e851e58219d428359e1#diff-d8af920ff77345cde4bbaabaca3cb13cR175
#include <pthread.h>
#include <assert.h>

//trigger structure
int trigger_use_count = 1;
int trigger_has_ops = 0;
int trigger_reenable_function = 0;
int trigger_ops_has_tryreenable_function = 1;


//constants
int CONFIG_IIO_CONSUMERS_PER_TRIGGER = 1;
int trig_subirqs_enabled = 0;

void *thread1(void *args);
void *thread2(void *args);

//threads
void *thread1(void *args)   //iio_trigger_poll()
{
  int tmp=0;
  int i=0;
  int j=0;

  if (trigger_use_count != 0) {
    //while (i < CONFIG_IIO_CONSUMERS_PER_TRIGGER) {
    if (i < trig_subirqs_enabled) {
      //BEGIN ASEC
      tmp = trigger_use_count;
      trigger_use_count = tmp + 1;
      //END ASEC
    }
    else {
      //inline iio_trigger_notify_done();
      //BEGINN_ASEC
      tmp = trigger_use_count;
      trigger_use_count = tmp + 1;
      if (trigger_use_count)
        if(trigger_has_ops && trigger_ops_has_tryreenable_function){
          //END ASEC
          if (trigger_reenable_function)
            // Missed an interrupt so launch new poll now 
            //inline iio_trigger_poll()
            if (trigger_use_count != 0)
            {
              //while(j < CONFIG_IIO_CONSUMERS_PER_TRIGGER) {
              if (j < 4) {
                //BEGIN ASEC
                tmp = trigger_use_count;
                trigger_use_count = tmp + 1;
                //END ASEC
              }
              j++;
              //} // while (j < CONFIG ...
            }
        }
    } 
    i++;
    //} // while (i < CONF...
  } // if ( trigger_use_count != 0)
  return NULL;
}

void *thread2(void *args)  
{				
  int tmp = trigger_use_count;
  trigger_use_count = tmp + 1;
  return NULL;
}


int main() {
  pthread_t t1, t2;

  pthread_create(&t1, NULL, thread1, NULL);
  pthread_create(&t2, NULL, thread2, NULL);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

  assert(trigger_use_count == 3);

  return trigger_use_count;
}
