//NEWBUG02. race-condition in broadcom tigon3 ethernet driver.
//problem: stats variable is not locked against concurrent access. could lead to inconsistent state.
//url: https://github.com/torvalds/linux/commit/0f566b208b41918053b2e67399673aaec02dde5d#diff-ee9b0abeec638cc316efd5b30e0e01e8R12576
//
// Markus: Modified to have one thread free and one thread modify
//
// `stats` is the "structure" modified if it is non-zero
#include <pthread.h>

//variables
int dev = 1;
int stats = 1;
int old_stats; //not relevant how old_stats get assigned
int buffertoprint = 1;
int dev_isalive = 1;

//constants
int EINVAL=22;

int rx_packets = 1;
int tx_packets = 1;
int rx_bytes = 1;
int tx_bytes = 1;
int rx_errors = 1;
int tx_errors = 1;
int multicast = 1;
int collisions = 1;
int length_errors = 1;
int rx_over_errors = 1;
int rx_frame_errors = 1;
int tx_aborted_errors = 1;
int tx_carrier_errors = 1;
int rx_crc_errors = 1;
int rx_missed_errors = 1;
int tp_rx_dropped = 1;
int tp_tx_dropped = 1;

void *thread1(void *args);
void *thread2(void *args);

// Thread 1: Modification thread
void *thread1(void *args)//netstat_show()
{
  int tmp = 0;
  int ret = EINVAL;

  if (dev_isalive) {
    if(!stats)
    {
      ret =  old_stats;
    }
    else {
      tmp = old_stats;
      stats = tmp + rx_packets;
      tmp = old_stats;
      stats = tmp + tx_packets;
      tmp = old_stats;
      stats = tmp + rx_bytes;
      tmp = old_stats;
      stats = tmp + tx_bytes;
      tmp = old_stats;
      stats = tmp + rx_errors;
      tmp = old_stats;
      stats = tmp + tx_errors;
      tmp = old_stats;
      stats = tmp + multicast;
      tmp = old_stats;
      stats = tmp + collisions;
      tmp = old_stats;
      stats = tmp + length_errors;
      tmp = old_stats;
      stats = tmp + rx_over_errors;
      tmp = old_stats;
      stats = tmp + rx_frame_errors;
      tmp = old_stats;
      stats = tmp + tx_aborted_errors;
      tmp = old_stats;
      stats = tmp + tx_carrier_errors;
      tmp = old_stats;
      stats = tmp + rx_crc_errors;
      tmp = old_stats;
      stats = tmp + rx_missed_errors;
      tmp = old_stats;
      stats = tmp + tp_rx_dropped;
      tmp = old_stats;
      if (stats == 0) { assert(0); }
      stats = tmp + tp_tx_dropped;
      tmp = buffertoprint;
      ret = tmp + stats;
    }
  }
  return NULL;
}

// Thread 2: Free()ing thread
// tg3_free_consistent()
void *thread2(void *args) 
{
  if (dev_isalive) {
    if(stats)
    {
      stats = 0;
    }
  }
  return NULL;
}

int main() {
  pthread_t t1, t2;
  // Everything is statically initialized at the top of the file
  pthread_create(&t1, NULL, thread1, NULL);
  pthread_create(&t2, NULL, thread2, NULL);

  pthread_exit(NULL);
}
