// From: http://pages.cs.wisc.edu/~remzi/OSTEP/threads-locks-usage.pdf
// Page: 10
//
// Markus: Modified to use an array instead of a linked list

#include <stdlib.h>
#include <pthread.h>
#include <assert.h>
#include <stdint.h>

#define SIZE_TYPE int8_t
#define VALUE_TYPE char
#define MAX_SIZE 5

// Queue
SIZE_TYPE head;
SIZE_TYPE tail;
SIZE_TYPE size;
VALUE_TYPE items[MAX_SIZE];
pthread_mutex_t headLock;
//pthread_mutex_t tailLock;
// =======

void Queue_Init(void) {
  head = 0;
  tail = 0;
  size = 0;
  pthread_mutex_init(&headLock, NULL);
  //pthread_mutex_init(&tailLock, NULL);
}

void Queue_Enqueue_t1(VALUE_TYPE value) {
  //pthread_mutex_lock(&tailLock);
  tail += 1;
  size++;
  items[tail] = value;
  //pthread_mutex_unlock(&tailLock);
}

void Queue_Enqueue_t2(VALUE_TYPE value) {
  //pthread_mutex_lock(&tailLock);
  tail += 1;
  size++;
  items[tail] = value;
  //pthread_mutex_unlock(&tailLock);
}

//int Queue_Dequeue(VALUE_TYPE *value) {
int Queue_Dequeue(void) {
  pthread_mutex_lock(&headLock);
  SIZE_TYPE h = head;
  //if (h == -1) {
  if (size == 0) {
    pthread_mutex_unlock(&headLock);
    return -1; // queue was empty
  }
  //*value = items[h];
  head += 1;
  size--;
  pthread_mutex_unlock(&headLock);
  return 0;
}

void *t1_main() {
  Queue_Enqueue_t1(1);
  return NULL;
}

void *t2_main() {
  Queue_Enqueue_t2(2);
  return NULL;
}

int main() {
  pthread_t t1;
  pthread_t t2;

  Queue_Init();

  pthread_create(&t1, NULL, t1_main, NULL);
  pthread_create(&t2, NULL, t2_main, NULL);

  pthread_join(t1, NULL);
  pthread_join(t2, NULL);

  VALUE_TYPE v1;
  VALUE_TYPE v2;
  //int r1 = Queue_Dequeue(&v1);
  //int r2 = Queue_Dequeue(&v2);
  int r1 = Queue_Dequeue();
  int r2 = Queue_Dequeue();

  //assert(r1 != -1);
  //assert(r2 != -1);
  if (r1 == -1) {
    assert(0);
  }
  if (r2 == -1) {
    assert(0);
  }

  return 0;
}
