## Readme

### Source
Source: http://web.eecs.umich.edu/~jieyu/bugs/mysql-12848.html

MySQL Source:
http://web.eecs.umich.edu/~jieyu/bugs/mysql-12848/mysql-4.0.26.tar.gz

The above source is also stored on the git repo and I (markus) should have a
local copy.

Bug Report: http://bugs.mysql.com/bug.php?id=12848

### Description
Example program displaying an atomicity violation in MySQL-4.0.26. The bug
involves a cache resize function that is not atomic, leading to intermediate
values of the cache size to be used in other threads. This could result in
another function using a cache that is actually freed but has an incorrect size
which is greater than 0

### Buggy Interleaving
~~~~~
Thread 1				|Thread 2
----------------------------------------|-------------------------------------
cache_resize() {			|
    cache_free() {			|
	lock(guard_mutex);		|
	free(cache.data);		|
	...				|
	unlock(guard_mutex);		|
	...				|
    }					|
    cache.size = newSize;		|
					| cache_store_query() {
					|	if (cache.size > 0)
					|	    // store data
    cache_init();			|
~~~~~

This results in the incorrect size being used in Thread 2. The cache is used
before it is initilized and the other thread is not aware that a resizing
operation is occuring

### Usage
~~~~~
gcc mysql-12848_01.c -lpthread
./a.out
~~~~~

### Building MySQL
The following tool are required to build MySQL:

* gunzip
* tar
* ANSI C++ Compiler (reccomended gcc >2.95.2)
* make (reccomended GNU make >3.75)

The README states that a simple `./configure` `make` `make install` should
work, however, my `./configure` failed. The project is looking for
`linuxthreads` which is not the thread implementation used on my system so I
could not compile the program.
