/* Testcase from Threader's distribution. For details see:
   http://www.model.in.tum.de/~popeea/research/threader

   This file is adapted from the example introduced in the paper:
   Thread-Modular Verification for Shared-Memory Programs 
   by Cormac Flanagan, Stephen Freund, Shaz Qadeer.
*/

#include <pthread.h>
//#define assert(e) if (!(e)) ERROR: goto ERROR;

int w=0, r=0, x, y;

/*
void __VERIFIER_atomic_take_write_lock() {
  __VERIFIER_assume(w==0 && r==0);
  w = 1;
  return;
} 
*/
#if 0
void take_write_lock() {
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0 && r==0);
  w = 1;
  __CPROVER_atomic_end();
  return;
} 
#endif

/*
void __VERIFIER_atomic_take_read_lock() {
  __VERIFIER_assume(w==0);
  //  r = r+1;
  int tmp = r;
  tmp = tmp + 1;
  r = tmp;
  return;
}
*/

#if 0
void take_read_lock() {
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0);
  int tmp = r;
  tmp = tmp + 1;
  r = tmp;
  __CPROVER_atomic_end();
  return;
}
#endif

void *writer1() { //writer
  //take_write_lock();  
  // inlined take_write_lock()
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0 && r==0);
  w = 1;
  __CPROVER_atomic_end();
  // end inline: take_write_lock()
  x = 3;
  w = 0;
  return NULL;
}
void *writer2() { //writer
  //take_write_lock();  
  // inlined take_write_lock()
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0 && r==0);
  w = 1;
  __CPROVER_atomic_end();
  // end inline: take_write_lock()
  x = 3;
  w = 0;
  return NULL;
}

void *reader1() { //reader
  int l;

  //take_read_lock();
  // inlined: take_read_lock()
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0);
  int tmp = r;
  tmp = tmp + 1;
  r = tmp;
  __CPROVER_atomic_end();
  // end inline: take_read_lock()

  l = x;
  y = l;
  assert(y == x);
  l = r-1;
  r = l;
  //y = x;
  //if (y != x) {
    //assert(0);
  //}
  return NULL;
}

void *reader2() { //reader
  int l;

  //take_read_lock();
  // inlined: take_read_lock()
  __CPROVER_atomic_begin();
  __VERIFIER_assume(w==0);
  int tmp = r;
  tmp = tmp + 1;
  r = tmp;
  __CPROVER_atomic_end();
  // end inline: take_read_lock()

  l = x;
  y = l;
  assert(y == x);
  l = r-1;
  r = l;
  //y = x;
  //if (y != x) {
    //assert(0);
  //}
  return NULL;
}

int main() {
  pthread_t t1, t2, t3, t4;
  pthread_create(&t1, 0, writer1, 0);
  pthread_create(&t2, 0, reader1, 0);
  pthread_create(&t3, 0, writer2, 0);
  pthread_create(&t4, 0, reader2, 0);
//  pthread_join(t1, 0);
//  pthread_join(t2, 0);
//  pthread_join(t3, 0);
//  pthread_join(t4, 0);
  return 0;
}
